﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Collections;

namespace TagCloudV1
{
    public partial class TagCloudv1 : Form
    {
        public class TagData
        {
            private int Vol;
            private string TP;
            private int sz;
            public int Volume
            {
                get { return Vol; }
                set { Vol = value; }
            }
            public string TagPhrase
            {
                get { return TP; }
                set { TP = value; }
            }
            public int Size
            {
                get { return sz; }
                set { sz = value; }
            }
        }


        TagData[] arrData;
        TextBox[] boxDisplay;
        string wordfile = "tweet_data.txt";
        int tagphrase_total = 10;       //made larger eventually
        int maxX = 800;     //find a way to dynamically size x and y based on form
        int maxY = 800;


        public TagCloudv1()
        {
            InitializeComponent();

            //FIRST: BRING THE DATA IN
            //Open the file
            if (!File.Exists(wordfile))
                MessageBox.Show("File Not Found");
            string[] lines = File.ReadAllLines(wordfile);
            char[] delims = { '~' };
            string[] tstring;
            //create an array of of TagData elements: name and volume
            TagData[] TD = new TagData[tagphrase_total];     //make larger
            for (int i = 0; i < tagphrase_total; i++)
            {
                TD[i] = new TagData();
            }
            arrData = TD;

            //populate the array with the data from the file
            for (int n = 0; n < tagphrase_total; n++)
            {
                tstring = lines[n].Split(delims);
                arrData[n].TagPhrase = tstring[0];
                arrData[n].Volume = Convert.ToInt32(tstring[1]);
                arrData[n].Size = 20;   //default size; actual size to be determined later
            }

            //SECOND: Determine font size for each tag phrase
            DetermineFontSize();

            //testing Font Size
            //            for (int i = 0; i<tagphrase_total; i++)
            //            {
            //                MessageBox.Show(arrData[i].TagPhrase + arrData[i].Volume.ToString() +
            //                   arrData[i].Size.ToString());
            //            }

            //THIRD: Place items on screen
            ScreenPlacement();

        }

        public void DetermineFontSize()
        {
            //Tweet volume for the most popular tweets runs in the tens of thousands
            //if not hundreds of thousands. To create numbers that work more easily 
            //with font sizes and algorithms,  I'm fitting them into ranges, so they are
            //something smaller and more managable.  Font sizes are not an exact 1:1
            //ratio to tweet volume; they are a general reflection of popularity, so 
            //if some information is lost in the fitting, it is not a big loss.

            for (int i = 0; i < tagphrase_total; i++)
            {
                if (arrData[i].Volume > 410000)
                    arrData[i].Size = 65;
                else if (arrData[i].Volume <= 410000 && arrData[i].Volume > 380000)
                    arrData[i].Size = 60;
                else if (arrData[i].Volume <= 380000 && arrData[i].Volume > 350000)
                    arrData[i].Size = 56;
                else if (arrData[i].Volume <= 350000 && arrData[i].Volume > 320000)
                    arrData[i].Size = 52;
                else if (arrData[i].Volume <= 320000 && arrData[i].Volume > 290000)
                    arrData[i].Size = 48;
                else if (arrData[i].Volume <= 290000 && arrData[i].Volume > 260000)
                    arrData[i].Size = 44;
                else if (arrData[i].Volume <= 260000 && arrData[i].Volume > 230000)
                    arrData[i].Size = 40;
                else if (arrData[i].Volume <= 230000 && arrData[i].Volume > 200000)
                    arrData[i].Size = 36;
                else if (arrData[i].Volume <= 200000 && arrData[i].Volume > 160000)
                    arrData[i].Size = 32;
                else if (arrData[i].Volume <= 160000 && arrData[i].Volume > 130000)
                    arrData[i].Size = 28;
                else if (arrData[i].Volume <= 130000 && arrData[i].Volume > 100000)
                    arrData[i].Size = 24;
                else if (arrData[i].Volume <= 100000 && arrData[i].Volume > 75000)
                    arrData[i].Size = 20;
                else if (arrData[i].Volume <= 75000 && arrData[i].Volume > 45000)
                    arrData[i].Size = 16;
                else if (arrData[i].Volume <= 45000 && arrData[i].Volume > 25000)
                    arrData[i].Size = 13;
                else if (arrData[i].Volume <= 25000 && arrData[i].Volume > 10000)
                    arrData[i].Size = 10;
                else                //anything less than 10,000 volume
                    arrData[i].Size = 7;

            }

        }

        public void ScreenPlacement()
        {
            TextBox[] boxDisplay = new TextBox[tagphrase_total];

            for (int i = 0; i < tagphrase_total; i++)
            {
                TextBox tempbox = new TextBox();
                //set font size
                tempbox.Font = new Font(tempbox.Font.FontFamily, arrData[i].Size);
                tempbox.Text = arrData[i].TagPhrase;    //populate with array of tagphrases
                tempbox.Enabled = false;                //disable the box
                tempbox.BorderStyle = System.Windows.Forms.BorderStyle.None;    //turn off border
                //resize the box
                Size tsize = TextRenderer.MeasureText(tempbox.Text, tempbox.Font);
                tempbox.Width = tsize.Width;
                tempbox.Height = tsize.Height;
                //generate a random location for the text box
                Random rand = new Random();
                int xplace = (rand.Next(maxX - tsize.Width));   //maxX-width of text box
                int yplace = (rand.Next(maxY - tsize.Height));   //maxY-height of text box
                tempbox.Location = new Point(xplace, yplace);


                boxDisplay[i] = new TextBox();
                boxDisplay[i] = tempbox;
                //                MessageBox.Show("tempbox reassigned");
                //                this.Controls.Add(tempbox);     //to add it to the controls so it can be used
                this.Controls.Add(boxDisplay[i]);
            }
        }
    }
}
